package com.pcloud.common.core.constant;

/**
 * 短信模板常量 @描述：
 *
 * @作者：zhuyajie
 * @创建时间：2017年8月24日 下午7:55:33 @版本：1.0
 */
public class SMSTemplateConstant {

	/*-----usercenter-------*/
	/**
	 * 您的${role}手机号重置成功，${relateRole}重置后密码：
	 * 123456，绑定手机号:${phone}，请使用登录名：${phone}登录${loginRole}，为确保账号安全，请及时修改新的密码。
	 */
	public static final String PHONE_RESET_CODE = "SMS_21061100009";
	/**
	 * 亲爱的${name},恭喜您注册成功，请登录系统。
	 */
	public static final String REGISTER_SUCCESS_CODE = "SMS_21061100052";
	/**
	 * 您好，您的实名认证已审核通过，请登录PC端查看，您的提现微信为您实名认证的微信账户，昵称：${nickName}，请知悉！
	 */
	public static final String AUTHENTICATE_SUCCESS_CODE = "SMS_21061100053";
	/**
	 * 您好，您的实名认证审核不通过，不通过原因${reason}，为便于您提现，请尽快登录PC端重新提交实名信息，感谢您的配合！
	 */
	public static final String AUTHENTICATE_FAILURE_CODE = "SMS_21061100054";
	/**
	 * 亲爱的${name}，非常遗憾，您的注册失败了，失败原因是：${reason}。
	 */
	public static final String REGISTER_FAILURE_REASON_CODE = "SMS_21061100055";
	/**
	 * 亲爱的${name}，非常遗憾，您的注册失败了，请重新注册。
	 */
	public static final String REGISTER_FAILURE_CODE = "SMS_21061100056";

	/**
	 * 尊敬的客户，蓝海系统将在${days}天内到期，如需继续使用请尽快与蓝海工作人员联系。
	 */
	public static final String EXPIRE_NOTICE_CODE = "SMS_21061100057";

	/*------appcenter------*/
	/**
	 * ${name}，您申请的一键式新增服务已完成，请登录帐户查看，感谢支持！
	 */
	public static final String ASSIST_CODE = "SMS_21061100058";
	/**
	 * 应用${name}资源压缩包下载地址为：https://download.5rs.me/${info}，请复制地址至电脑端下载。
	 */
	public static final String APP_RESOURCE_DOWNLOAD_CODE = "SMS_21061100019";
	/**
	 * 应用${name}资源压缩包下载地址为：https://surl.5rs.me/${info}，请复制地址至电脑端下载。
	 */
	public static final String APP_RESOURCE_DOWNLOAD_CODE_NEW = "SMS_21061100020";

	/*--- messagecenter---*/
	/**
	 * 您好，来自${company}公司的${name}客户对蓝海产品很感兴趣，有意向与您建立合作关系，
	 * 他的联系方式为：${phone},请尽快与他联系，详细的信息请登录邮箱查看，如果收不到邮件，请注意查看垃圾邮箱。
	 */
	public static final String INVITE_CODE = "SMS_21061100021";
	/**
	 * 您的注册验证码是${code}，验证码有效期5分钟。如非本人操作，请勿理会。
	 */
	public static final String REGISTER_VERIFY_CODE = "SMS_21061100022";
	/**
	 * 您的下载验证码是${code}，验证码有效期5分钟。如非本人操作，请勿理会。
	 */
	public static final String DOWNLOAD_VERIFY_CODE = "SMS_21061100023";
	/**
	 * 您的验证码是${code}，验证码有效期5分钟。如非本人操作，请勿理会。
	 */
	public static final String VERIFY_CODE = "SMS_21061100024";
	/**
	 * 您的验证码为${code},验证码有效期5分钟，此验证码用于绑定手机号到蓝海平台。如非本人操作，请勿理会。
	 */
	public static final String PHONE_BIND_VERIFY_CODE = "SMS_21061100025";
	/**
	 * 书刊${bookName}中的${targetName}已被${partyName}修改。
	 */
	public static final String FUND_QRCODE_MODIFY = "SMS_21061100026";
	/**
	 * 书刊${bookName}中的${targetName}已修改，详情见RAYS平台端书刊内容监控。
	 */
	public static final String FUND_APP_OR_PRODUCT_MODIFY = "SMS_21061100027";
	/**
	 * 书刊${bookName}中的${targetName}已被${partyName}修改价格，详情见RAYS平台端基金书刊监控。
	 */
	public static final String FUND_APP_OR_PRODUCT_MODIFY_PRICE = "SMS_21061100028";
	/**
	 * 书刊${bookName}中的${targetName}已被${partyName}取消关联。
	 */
	public static final String FUND_QRCODE_DISASSOCIATION = "SMS_21061100029";
	/**
	 * 书刊${bookName}中的${targetName}已被${partyName}调整资源，详情见RAYS平台端基金书刊监控。
	 */
	public static final String FUND_APP_OR_PRODUCT_RESOURCE_RELATION = "SMS_21061100030";

	/*-------resourcecenter------*/
	/**
	 * 您购买的${name}下载地址为：https://download.5rs.me/${info}，请复制至电脑端下载。
	 */
	public static final String RESOURCE_DOWNLOAD_CODE = "SMS_21061100031";
	/**
	 * 您购买的${name}下载地址为：https://surl.5rs.me/${info}，请复制至电脑端下载。
	 */
	public static final String RESOURCE_DOWNLOAD_CODE_NEW = "SMS_21061100032";

	/*------settlementcenter------*/
	/**
	 * 您收到一条提现审核申请，${name}出版社申请提现${money}元，请抽空处理。
	 */
	public static final String WITHDRAW_CODE = "SMS_21061100033";

	/*-----bm------*/
	/**
	 * 抱歉，您的报名申请审核失败。
	 */
	public static final String BM_AUDIT_FAIL_CODE = "SMS_21061100034";
	/**
	 * 恭喜您，您所提交的参赛方案${name}已入围，请至出版融合技术编辑创新大赛官方渠道查看详情。
	 */
	public static final String BM_AUDIT_PASS_CODE = "SMS_21061100035";

	/*-----questionair-------*/
	/**
	 * https://download.5rs.me/${info},有效期48小时，请及时下载。
	 */
	public static final String QUESTIONAIR_DOWNLOAD_CODE = "SMS_21061100036";

	/*----liveapp-----*/
	/**
	 * 您预约的直播还有一个小时开始。
	 */
	public static final String APPOINTMENT_CODE = "SMS_21061100038";

	/**
	 * 尊敬的${name}老师，您的课程${title}报名人数已达${number}人，将于${time}开播，提醒您提前做好准备，预祝直播顺利！
	 */
	public static final String START_COURSE_NOTICE = "SMS_21061500010";

	/*----------tradecenter------------*/
	/**
	 * 您有一个超过24小时的订单没有发货，请及时处理！
	 */
	public static final String ORDER_NOTICE_CODE = "SMS_21061100040";

	/*----------channelcenter------------*/
	/**
	 * 论文邮件提醒 亲爱的作者${merchantName}，恭喜您，您的论文《${sceneName}》被录取了，请注意查收邮件，谢谢！
	 */
	public static final String OSID_EMAIL_CODE = "SMS_21061100041";

	/**
	 * 应用${name}资源压缩包下载地址为：https://s.5rs.me/${info}，请复制地址至电脑端下载。
	 */
	public static final String APP_RESOURCE_DOWNLOAD_CODE_OWN = "SMS_21061100042";

	/**
	 * 您购买的${name}下载地址为：https://s.5rs.me/${info}，请复制至电脑端下载。
	 */
	public static final String RESOURCE_DOWNLOAD_CODE_OWN = "SMS_21061100043";

	/**
	 * ${agentName}的${name}，注册了RAYS蓝海的体验账号，联系方式为：${phone}。
	 */
	public static final String USER_INFO_CODE = "SMS_21061100044";

	/**
	 *您好，有${count}位客户对RAYS蓝海产品很感兴趣，有意向体验，详细信息请登录邮箱${mailName}@dcrays.cn查看，
	 * 如果收不到邮件，请注意查看垃圾邮箱。
	 */
	public static final String EXPERIENCE_CODE = "SMS_21061100045";

	/**
	 * ${name}您好，现${agentName}出版社与我司合作分成协议将于${date}到期。请您书面通知该单位，并联系市场部项目负责人跟进续约事宜。
	 */
	public static final String DEALINE_CODE = "95ac78b7eff34cfeb613a7710aa7a959";

	/**
	 * 【第四届编创赛】恭喜您提交成功，组委会将在7个工作日内完成审核，请耐心等待。您可到www.necis.me查看已报名信息。
	 */
	public static final String NECIS_SUBMIT = "SMS_21061100047";

	/**
	 * 【第四届编创赛】恭喜您进入第4届出版技术融合·编辑创新大赛复审环节，请到www.necis.me下载打印纸质报名表并加盖公章、同印量证明及纸质出版物邮寄至大赛组委会。
	 * 邮寄地址：湖北省武汉市洪山区梨园街欢乐大道1号德成国贸中心一层武汉文化金融服务中心 武汉理工数字传播工程有限公司 
	 * 电话：15623088490‬（叶老师）
	 */
	public static final String NECIS_AUDIT_SUCCESS = "SMS_21061100049";

	/**
	 * 【第四届编创赛】很抱歉，您提交的第4届出版技术融合·编辑创新大赛报名资料审核未通过，您可到www.necis.me查看具体结果。
	 */
	public static final String NECIS_AUDIT_FAIL = "SMS_21061100048";

	/**
	 * 恭喜您进入评选环节，请耐心等待奖项公布。若评选通过，组委会工作人员会第一时间跟您联系。
	 */
	public static final String NECIS_REVIEW_SUCCESS = "SMS_21061100050";

	/**
	 * 很抱歉，您提交的出版物不符合报名条件。
	 */
	public static final String NECIS_REVIEW_FAIL = "SMS_21061100051";

	/**
	 * [书僮小睿]您的验证码是${code}，验证码有效期5分钟。如非本人操作，请勿理会。
	 */
	public static final String RAYS_VERIFY_CODE = "SMS_21061100004";

	/**
	 * 服务${serveName}剩余使用数量已不足20%, 请及时充值。
	 */
	public static final String ALERT_MESSAGE_COUNT = "SMS_21092600006";
}
