/**
 *
 */
package com.pcloud.common.core.dto;

import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @描述：
 * 
 * @作者：songx
 * @创建时间：2017年2月27日,上午11:23:29 @版本：1.0
 */
public class ConvertQueueDto implements Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 7968821573480010447L;

	/**
	 * 标识
	 */
	private Long id;

	/**
	 * 文件UUID
	 */
	private String fileId;

	/**
	 * 来源类型
	 */
	private String fromType;

	/**
	 * 自定义类型，fromType的二级类型
	 */
	@ApiModelProperty(name = "自定义类型", dataType = "String")
	private String customType;

	/**
	 * 视频截图时间点
	 */
	private int snapshotTime;

	/**
	 * 来源标识
	 */
	private Long fromId;

	/**
	 * 文件路径
	 */
	private String fileUrl;

	/**
	 * 文件大小
	 */
	private Long fileSize;

	/**
	 * 文件类型
	 */
	private String fileType;

	/**
	 * 在缓存中被处理的次数
	 */
	private int processTimes = 0;

	/**
	 * 转换成功标记，true：成功，false失败
	 */
	private Boolean state;

	/**
	 * 封面图
	 */
	private String coverImg;

	/**
	 * 使用地址
	 */
	private String pilotUrl;

	/**
	 * 视频时长
	 */
	private BigDecimal duration;

	/**
	 * 视频m3u8地址
	 */
	private String m3u8Url;

	public int getSnapshotTime() {
		return snapshotTime;
	}

	public void setSnapshotTime(int snapshotTime) {
		this.snapshotTime = snapshotTime;
	}

	public String getCustomType() {
		return customType;
	}

	public void setCustomType(String customType) {
		this.customType = customType;
	}

	public String getM3u8Url() {
		return m3u8Url;
	}

	public void setM3u8Url(String m3u8Url) {
		this.m3u8Url = m3u8Url;
	}

	public BigDecimal getDuration() {
		return duration;
	}

	public void setDuration(BigDecimal duration) {
		this.duration = duration;
	}

	public Long getFromId() {
		return fromId;
	}

	public void setFromId(Long fromId) {
		this.fromId = fromId;
	}

	public String getPilotUrl() {
		return pilotUrl;
	}

	public void setPilotUrl(String pilotUrl) {
		this.pilotUrl = pilotUrl;
	}

	public String getCoverImg() {
		return coverImg;
	}

	public void setCoverImg(String coverImg) {
		this.coverImg = coverImg;
	}

	public Boolean getState() {
		return state;
	}

	public void setState(Boolean state) {
		this.state = state;
	}

	public String getFileType() {
		return fileType;
	}

	public void setFileType(String fileType) {
		this.fileType = fileType;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getFileId() {
		return fileId;
	}

	public void setFileId(String fileId) {
		this.fileId = fileId;
	}

	public String getFromType() {
		return fromType;
	}

	public void setFromType(String fromType) {
		this.fromType = fromType;
	}

	/**
	 * @return Returns the fileUrl.
	 */
	public String getFileUrl() {
		return fileUrl;
	}

	/**
	 * @param fileUrl
	 *            The fileUrl to set.
	 */
	public void setFileUrl(String fileUrl) {
		this.fileUrl = fileUrl;
	}

	/**
	 * @return Returns the fileSize.
	 */
	public Long getFileSize() {
		return fileSize;
	}

	/**
	 * @param fileSize
	 *            The fileSize to set.
	 */
	public void setFileSize(Long fileSize) {
		this.fileSize = fileSize;
	}

	public int getProcessTimes() {
		return processTimes;
	}

	public void setProcessTimes(int processTimes) {
		this.processTimes = processTimes;
	}

	@Override
	public String toString() {
		return "ConvertQueueDto [fileId=" + fileId + ", fromType=" + fromType + ", fileUrl=" + fileUrl + ", fileSize="
				+ fileSize + ", fileType=" + fileType + ", state=" + state + ", coverImg=" + coverImg + ", pilotUrl="
				+ pilotUrl + "]";
	}

}
