package com.pcloud.common.core.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 
 * @描述：发邮件dto
 * @作者：zhuyajie
 * @创建时间：2016年11月30日 上午10:19:06
 * @版本：1.0
 *
 * update：
 * 2020/07/22  增加抄送地址ccEmail
 */
public class SendEmailDto implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 8026368438145316971L;
	/**
	 * 接收方邮件地址
	 */
	private String toEmail;

	/**
	 * 抄送地址
	 */
	private String ccEmail;
	/**
	 * typeCode
	 */
	private String typeCode;
	/**
	 * 内容
	 */
	private Map<String, Object> content;
	/**
	 * 附件
	 */
	private List<Map<String, Object>> file;
	/**
	 * 发件人昵称
	 */
	private String nickName;
	/**
	 * 附件路径是否为短链接
	 */
	private Boolean isShortUrl;
	/**
	 * 文件大小
	 */
	private Long fileSize;
	/**
	 * 邮件列表
	 */
	private List<String> toEmails;
	/**
	 * 邮件主题
	 */
	private String emailSubject;

	public String getToEmail() {
		return toEmail;
	}
	public void setToEmail(String toEmail) {
		this.toEmail = toEmail;
	}
	public String getTypeCode() {
		return typeCode;
	}
	public void setTypeCode(String typeCode) {
		this.typeCode = typeCode;
	}
	public Map<String, Object> getContent() {
		return content;
	}
	public void setContent(Map<String, Object> content) {
		this.content = content;
	}
	public List<Map<String, Object>> getFile() {
		return file;
	}
	public void setFile(List<Map<String, Object>> file) {
		this.file = file;
	}
	public String getNickName() {
		return nickName;
	}
	public void setNickName(String nickName) {
		this.nickName = nickName;
	}

	public Boolean getIsShortUrl() {
		return isShortUrl;
	}

	public void setIsShortUrl(Boolean isShortUrl) {
		this.isShortUrl = isShortUrl;
	}

	public Long getFileSize() {
		return fileSize;
	}

	public void setFileSize(Long fileSize) {
		this.fileSize = fileSize;
	}

	public String getCcEmail() {
		return ccEmail;
	}

	public void setCcEmail(String ccEmail) {
		this.ccEmail = ccEmail;
	}

	public List<String> getToEmails() {
		return toEmails;
	}

	public void setToEmails(List<String> toEmails) {
		this.toEmails = toEmails;
	}

	public String getEmailSubject() {
		return emailSubject;
	}

	public void setEmailSubject(String emailSubject) {
		this.emailSubject = emailSubject;
	}

	@Override
	public String toString() {
		return "SendEmailDto{" +
				"toEmail='" + toEmail + '\'' +
				", typeCode='" + typeCode + '\'' +
				", content=" + content +
				", file=" + file +
				", nickName='" + nickName + '\'' +
				", isShortUrl=" + isShortUrl +
				", fileSize=" + fileSize +
				'}';
	}
}
